diff --git a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java b/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
similarity index 90%
rename from src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
rename to game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index 203c3464d..03db008f3 100644
--- a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -5,9 +5,9 @@ import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
 import net.minecraft.core.net.handler.PacketHandler;
-import net.minecraft.core.net.packet.DisconnectPacket;
+import net.minecraft.core.net.packet.PacketDisconnect;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PingHandshakePacket;
+import net.minecraft.core.net.packet.PacketPingHandshake;
 
 import java.io.IOException;
 import java.net.InetAddress;
@@ -52,7 +52,7 @@ public class PingPacketHandler
     }
 
     @Override
-    public void handleKickDisconnect(DisconnectPacket packet) {
+    public void handleKickDisconnect(PacketDisconnect packet) {
         if (packet.reason.startsWith("§1"))
         {
             String[] serverInfo = packet.reason.split("\0");
@@ -62,7 +62,7 @@ public class PingPacketHandler
             server.motd = serverInfo[3];
             server.currentPlayers = parseIntWithDefault(serverInfo[4], -1);
             server.maxPlayers = parseIntWithDefault(serverInfo[5], -1);
-            server.latency = System.currentTimeMillis() - PingHandshakePacket.startTime;
+            server.latency = System.currentTimeMillis() - PacketPingHandshake.startTime;
 
             screen.handleIncomingServerInfo(server);
 
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
similarity index 92%
rename from src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
rename to game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
index aa71ad74e..f914ade77 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
+++ b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
@@ -6,7 +6,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
 import net.minecraft.core.net.handler.PacketHandler;
-import net.minecraft.core.net.packet.PingHandshakePacket;
+import net.minecraft.core.net.packet.PacketPingHandshake;
 
 public class ThreadPingServer
     extends Thread {
@@ -47,7 +47,7 @@ public class ThreadPingServer
 
         try {
             netHandler = new PingPacketHandler(screen, server);
-            netHandler.addToSendQueue(new PingHandshakePacket(0x01, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
+            netHandler.addToSendQueue(new PacketPingHandshake(0x01, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
         } catch (Exception ignored) {
         } finally {
             done = true;
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
similarity index 94%
rename from src/main/java/net/minecraft/client/player/controller/PlayerController.java
rename to game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 0f1591d45..52ea1add8 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -50,7 +51,7 @@ public abstract class PlayerController {
 			return;
 		}
 
-		Block mineBlock = Block.getBlock(mc.currentWorld.getBlockId(x, y, z));
+		Block mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(mineBlock != null) {
 			float mineStrength = mineBlock.blockStrength(mc.currentWorld, x, y, z, side, mc.thePlayer);
 			
@@ -76,7 +77,7 @@ public abstract class PlayerController {
 			return;
 		}
 		
-		Block mineBlock = Block.getBlock(mc.currentWorld.getBlockId(x, y, z));
+		Block mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(mineBlock != null) {	
 			syncCurrentPlayItem();
 			
@@ -149,7 +150,7 @@ public abstract class PlayerController {
 		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
 		setMineBlock(null, null, null);
 		World world = mc.currentWorld;
-		Block block = Block.getBlock(world.getBlockId(x, y, z));
+		Block block = Blocks.getBlock(world.getBlockId(x, y, z));
 		if(block == null) return false;
 		
 		Item heldItem = null;
@@ -184,7 +185,7 @@ public abstract class PlayerController {
 		if (!mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return;
 		mc.currentWorld.onBlockHit(mc.thePlayer, x, y, z, side);
 		
-		Block block = Block.getBlock(mc.currentWorld.getBlockId(x, y, z));
+		Block block = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(block != null) {
 			block.onBlockLeftClicked(mc.currentWorld, x, y, z, mc.thePlayer, side, xHit, yHit);
 		}
@@ -265,7 +266,7 @@ public abstract class PlayerController {
 				}
 			}
 			if (!player.isSneaking() || itemstack == null) {  // If standing or hand empty perform block right click method
-				if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+				if (blockId > 0 && Blocks.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
 					return true;
 				}
 			}
@@ -276,7 +277,7 @@ public abstract class PlayerController {
 			}
 		} else {
 			if (!player.isSneaking()) {  // If standing or hand empty perform block right click method
-				if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+				if (blockId > 0 && Blocks.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
 					return true;
 				}
 			}
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
similarity index 79%
rename from src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
rename to game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 77314de29..21bb62d48 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -41,17 +41,17 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		super.hitBlock(x, y, z, side, xHit, yHit);
-		netHandler.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_DIG_CONTINUED, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_CONTINUED, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
 	public void sendStartDigPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_DIG_START, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_START, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
 	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_DIG_COMPLETE, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_COMPLETE, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
@@ -59,14 +59,14 @@ public class PlayerControllerMP extends PlayerController {
 		int i = mc.thePlayer.inventory.getCurrentItemIndex();
 		if (i != currentItem) {
 			currentItem = i;
-			netHandler.addToSendQueue(new SetCarriedItemPacket(currentItem));
+			netHandler.addToSendQueue(new PacketSetCarriedItem(currentItem));
 		}
 	}
 
 	@Override
 	public boolean useItemOn(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new UseItemPacket(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced));
+		netHandler.addToSendQueue(new PacketUseItem(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced));
 		boolean flag = super.useItemOn(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 		return flag;
 	}
@@ -74,7 +74,7 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	public boolean useItem(Player entityplayer, World world, ItemStack itemstack) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new UseItemPacket(-1, -1, -1, Direction.NONE, entityplayer.inventory.getCurrentItem(), 0, 0));
+		netHandler.addToSendQueue(new PacketUseItem(-1, -1, -1, Direction.NONE, entityplayer.inventory.getCurrentItem(), 0, 0));
 		boolean flag = super.useItem(entityplayer, world, itemstack);
 		return flag;
 	}
@@ -87,14 +87,14 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	public void attack(Player entityplayer, Entity entity) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new InteractPacket(entityplayer.id, entity.id, InteractPacket.ACTION_ATTACK));
+		netHandler.addToSendQueue(new PacketInteract(entityplayer.id, entity.id, PacketInteract.ACTION_ATTACK));
 		entityplayer.attackTargetEntityWithCurrentItem(entity);
 	}
 
 	@Override
 	public boolean interact(Player entityplayer, Entity entity) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new InteractPacket(entityplayer.id, entity.id, InteractPacket.ACTION_INTERACT));
+		netHandler.addToSendQueue(new PacketInteract(entityplayer.id, entity.id, PacketInteract.ACTION_INTERACT));
 		return entityplayer.useCurrentItemOnEntity(entity);
 	}
 
@@ -102,7 +102,7 @@ public class PlayerControllerMP extends PlayerController {
 	public ItemStack handleInventoryMouseClick(int windowId, InventoryAction action, int[] args, Player entityplayer) {
 		short actionId = entityplayer.craftingInventory.backup(entityplayer.inventory);
 		ItemStack itemstack = super.handleInventoryMouseClick(windowId, action, args, entityplayer);
-		netHandler.addToSendQueue(new ContainerClickPacket(windowId, action, args, itemstack, actionId));
+		netHandler.addToSendQueue(new PacketContainerClick(windowId, action, args, itemstack, actionId));
 		return itemstack;
 	}
 
@@ -116,6 +116,6 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	public void setPaintingType(ArtType art)
 	{
-		netHandler.addToSendQueue(new SetPaintingArtPacket(art));
+		netHandler.addToSendQueue(new PacketSetPaintingArt(art));
 	}
 }
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
similarity index 89%
rename from src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
rename to game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index 8633176a8..7f2bab88e 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -2,6 +2,7 @@ package net.minecraft.client.player.controller;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
@@ -26,7 +27,7 @@ public class PlayerControllerSP extends PlayerController {
 			item.onDestroyBlock(mc.currentWorld, id, x, y, z, side, mc.thePlayer);
 		}
 		if (removed && mc.thePlayer.getGamemode().dropBlockOnBreak()) {
-			Block.blocksList[id].harvestBlock(mc.currentWorld, mc.thePlayer, x, y, z, meta, tileEntity);
+			Blocks.blocksList[id].harvestBlock(mc.currentWorld, mc.thePlayer, x, y, z, meta, tileEntity);
 		}
 
 		if (item != null && item.stackSize <= 0)
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/ItemRenderer.java
rename to game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 7d8f00b72..64af7299f 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render;
 
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.block.ItemBlock;
 import org.lwjgl.opengl.GL11;
@@ -138,7 +139,7 @@ public class ItemRenderer
 			
 			int id = mc.currentWorld.getBlockId(blockX, blockY, blockZ);
             int meta = mc.currentWorld.getBlockMetadata(blockX, blockY, blockZ);
-            Block block = Block.blocksList[id];
+            Block block = Blocks.blocksList[id];
             BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
 			if(mc.currentWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
 				renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
@@ -159,8 +160,8 @@ public class ItemRenderer
                         break;
 					}
 				}
-                if(Block.blocksList[id] != null) {
-                    model = BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[id]);
+                if(Blocks.blocksList[id] != null) {
+                    model = BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[id]);
                     renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
                 }
 			}
diff --git a/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
similarity index 91%
rename from src/main/java/net/minecraft/client/render/ParticleEngine.java
rename to game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 13e593105..8ebdb9258 100644
--- a/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -9,6 +9,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -152,7 +153,7 @@ public final class ParticleEngine {
      * @param data The metadata value of the destroyed block.
      */
     public void destroy(int x, int y, int z, int id, int data) {
-        Block block = Block.blocksList[id];
+        Block block = Blocks.blocksList[id];
         if (block == null) return;
         int amount = 4;
         if (block == Blocks.FIRE) {
@@ -183,23 +184,24 @@ public final class ParticleEngine {
         if (id == 0) {
             return;
         }
-        Block block = Block.blocksList[id];
+        Block block = Blocks.blocksList[id];
+        AABB bounds = block.getBounds();
         float r = 0.1F;
-        double xp = x + rand.nextDouble() * (block.maxX - block.minX - (r * 2.0F)) + r + block.minX;
-        double yp = y + rand.nextDouble() * (block.maxY - block.minY - (r * 2.0F)) + r + block.minY;
-        double zp = z + rand.nextDouble() * (block.maxZ - block.minZ - (r * 2.0F)) + r + block.minZ;
+        double xp = x + rand.nextDouble() * (bounds.maxX - bounds.minX - (r * 2.0F)) + r + bounds.minX;
+        double yp = y + rand.nextDouble() * (bounds.maxY - bounds.minY - (r * 2.0F)) + r + bounds.minY;
+        double zp = z + rand.nextDouble() * (bounds.maxZ - bounds.minZ - (r * 2.0F)) + r + bounds.minZ;
         if (side == Side.BOTTOM) {
-            yp = (y + block.minY) - r;
+            yp = (y + bounds.minY) - r;
         } else if (side == Side.TOP) {
-            yp = (y + block.maxY) + r;
+            yp = (y + bounds.maxY) + r;
         } else if (side == Side.NORTH) {
-            zp = (z + block.minZ) - r;
+            zp = (z + bounds.minZ) - r;
         } else if (side == Side.SOUTH) {
-            zp = (z + block.maxZ) + r;
+            zp = (z + bounds.maxZ) + r;
         } else if (side == Side.WEST) {
-            xp = (x + block.minX) - r;
+            xp = (x + bounds.minX) - r;
         } else if (side == Side.EAST) {
-            xp = x + block.maxX + r;
+            xp = x + bounds.maxX + r;
         }
         add((new ParticleBlockBreaking(world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, world.getBlockMetadata(x, y, z))).init(x, y, z).setPower(0.2F).setScale(0.6F));
     }
diff --git a/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
similarity index 92%
rename from src/main/java/net/minecraft/client/render/RenderBlockCache.java
rename to game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
index c6ced206d..b9e628d80 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
@@ -4,6 +4,7 @@ import java.util.Arrays;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.WorldSource;
 
 final public class RenderBlockCache {
@@ -45,7 +46,7 @@ final public class RenderBlockCache {
 		float brightness = block.getBlockBrightness(access, x, y, z);
 
 		if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
-			int lightEmission = Block.lightEmission[block.id];
+			int lightEmission = Blocks.lightEmission[block.id];
 			if(lightEmission >= 15) {
 				return 1.0f;
 			}
@@ -80,7 +81,7 @@ final public class RenderBlockCache {
     public boolean getOpacity(int relX, int relY, int relZ) {
         int index = (relX+CACHE_RANGE)*CACHE_SIZE*CACHE_SIZE+(relY+CACHE_RANGE)*CACHE_SIZE+(relZ+CACHE_RANGE);
         if(!opacityCached[index]){
-            opacityValue[index] = Block.solid[access.getBlockId(relX+ offsetX, relY+ offsetY, relZ+ offsetZ)];
+            opacityValue[index] = Blocks.solid[access.getBlockId(relX+ offsetX, relY+ offsetY, relZ+ offsetZ)];
             opacityCached[index] = true;
         }
         return opacityValue[index];
@@ -89,7 +90,7 @@ final public class RenderBlockCache {
     public int getLightmapCoord(int relX, int relY, int relZ) {
     	int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
     	if(!lightmapCoordCached[index]) {
-    		int lightEmission = Block.lightEmission[block.id];
+    		int lightEmission = Blocks.lightEmission[block.id];
     		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, lightEmission);
     		lightmapCoordCached[index] = true;
     	}
